part of spark_widget;

class SparkWrapper<T> extends SparkFormWidget {
  const SparkWrapper({
    Key? key,
    required this.builder,
    required FormGroupItem manage,
  }) : super(key: key, manage: manage, enabled: true);

  final FormItemWrapperBuilder<T> builder;

  @override
  State<StatefulWidget> createState() => _SparkWrapperBase<T>();
}

class _SparkWrapperBase<T> extends SparkFormWidgetBase<SparkWrapper<T>, T> {
  void _handleValueChange(T value) {
    handleFormDataChange(value);
  }

  @override
  Widget build(BuildContext context) {
    return widget.builder(context, fieldData, _handleValueChange);
  }

  @override
  void valueChangeNotify() {
    if (!mounted) {
      return;
    }
    setState(() {});
  }

  @override
  bool handleGetValueChangeNotification(
    SparkBeaconNotification<dynamic> notification,
  ) {
    _handleValueChange(notification.value);
    return true;
  }
}
